<?php
   // no direct access
   defined('_JEXEC') or die;
   jimport( 'joomla.plugin.plugin' );

   class plgContentAEMeteo extends JPlugin
   {
      private $_extension  = '.gif' ;
      private $_profondeur = 0 ;
      private $_cache      = 'no' ;
      private $_affichage  = 'default' ;
      private $_linkCGU    = 'yes' ;
      private $_mode       = 'ville' ;
               
      public function __construct(&$subject, $params )
      {
         parent::__construct( $subject, $params );
         $this->_chemin     = JURI::root( true )."tmp" ;
         $this->_adresse    = JURI::base()."plugins/content/AEMeteo" ;
      }
      
      public function onContentPrepare($context, &$article, &$params, $offset = 0)
      {
         //Don't run this plugin when the content is being indexed
         if ($context == 'com_finder.indexer') 
         {
            return true;
         }

         // simple performance check to determine whether bot should process further
         if ((strpos($article->text, 'AEMeteoV') === false )  && (strpos($article->text, 'AEMeteoC') === false ))
         {
            return true;
         }		
                  
         // recuperation des parametres
         $this->_profondeur = $this->params->get('profondeur') ;
         $this->_cache      = $this->params->get('cache') ;
         $this->_affichage  = $this->params->get('affichage') ;
         $this->_linkCGU    = $this->params->get('linkCGU') ;

         // demande par Ville               	
         $regexV = '/{AEMeteoV\s+(.*?)}/i';
		   preg_match_all($regexV, $article->text, $matches, PREG_SET_ORDER);
		   if ($matches) 
		   {
   		   $this->_mode = 'ville' ;
			   foreach ($matches as $match) 
			   {
               $matcheslist = explode(',', $match[1]);
			      $ville = trim($matcheslist[0]);
				   $output = $this->_display(0,0,$ville);
				   // We should replace only first occurrence in order to allow positions with the same name to regenerate their content:
				   $article->text = preg_replace("|$match[0]|", $output, $article->text, 1);
			   }
		   }		   

         // demande par Coordonnees
         $regexV = '/{AEMeteoC\s+(.*?)}/i';
		   preg_match_all($regexV, $article->text, $matches, PREG_SET_ORDER);
		   if ($matches) 
		   {
   		   $this->_mode = 'coord' ;
			   foreach ($matches as $match) 
			   {
               $matcheslist = explode(',', $match[1]);
			      $lat = trim($matcheslist[0]);
			      $long = trim($matcheslist[1]);
			      
				   $output = $this->_display($lat, $long, '');
				   // We should replace only first occurrence in order to allow positions with the same name to regenerate their content:
				   $article->text = preg_replace("|$match[0]|", $output, $article->text, 1);
			   }
		   }	

		   return true;
      }      
      
      /* Function pour extraire les balises */
      private function _extract_data($data_brute){
      
      	//Ici on va lire les donnees et les mettre en forme
      	
      	//La date
      	$date = explode('date="',$data_brute);
      	$date = explode('"',$date[1]);
      	$date = $date[0];
      	
      	//Pictogrammes (liste disponible dans la documentation)
      	$pictos_matin = explode(' pictos_matin="',$data_brute);
      	$pictos_matin = explode('"',$pictos_matin[1]);
      	$pictos_matin = $pictos_matin[0];
      	$pictos_midi = explode(' pictos_midi="',$data_brute);
      	$pictos_midi = explode('"',$pictos_midi[1]);
      	$pictos_midi= $pictos_midi[0];
      	$pictos_apmidi = explode(' pictos_apmidi="',$data_brute);
      	$pictos_apmidi = explode('"',$pictos_apmidi[1]);
      	$pictos_apmidi= $pictos_apmidi[0];
      	$pictos_soir = explode(' pictos_soir="',$data_brute);
      	$pictos_soir = explode('"',$pictos_soir[1]);
      	$pictos_soir = $pictos_soir[0];
      	
      	//Condition meteo prevue
      	$namepictos_matin = explode(' namepictos_matin="',$data_brute);
      	$namepictos_matin = explode('"',$namepictos_matin[1]);
      	$namepictos_matin = $namepictos_matin[0];
      	$namepictos_midi = explode(' namepictos_midi="',$data_brute);
      	$namepictos_midi = explode('"',$namepictos_midi[1]);
      	$namepictos_midi= $namepictos_midi[0];
      	$namepictos_apmidi = explode(' namepictos_apmidi="',$data_brute);
      	$namepictos_apmidi = explode('"',$namepictos_apmidi[1]);
      	$namepictos_apmidi= $namepictos_apmidi[0];
      	$namepictos_soir = explode(' namepictos_soir="',$data_brute);
      	$namepictos_soir = explode('"',$namepictos_soir[1]);
      	$namepictos_soir = $namepictos_soir[0];
      	
      	//Temperature
      	$tempe_matin = explode(' tempe_matin="',$data_brute);
      	$tempe_matin = explode('"',$tempe_matin[1]);
      	$tempe_matin = $tempe_matin[0];
      	$tempe_midi = explode(' tempe_midi="',$data_brute);
      	$tempe_midi = explode('"',$tempe_midi[1]);
      	$tempe_midi= $tempe_midi[0];
      	$tempe_apmidi = explode(' tempe_apmidi="',$data_brute);
      	$tempe_apmidi = explode('"',$tempe_apmidi[1]);
      	$tempe_apmidi= $tempe_apmidi[0];
      	$tempe_soir = explode(' tempe_soir="',$data_brute);
      	$tempe_soir = explode('"',$tempe_soir[1]);
      	$tempe_soir = $tempe_soir[0];
      	
      	
      	//Nous alllons retourner une ligne contenant toutes les donnees
      	$return_data = $date."/".$pictos_matin."/".$namepictos_matin."/".$tempe_matin."/".$pictos_midi."/".$namepictos_midi."/".$tempe_midi."/".$pictos_apmidi."/".$namepictos_apmidi."/".$tempe_apmidi."/".$pictos_soir."/".$namepictos_soir."/".$tempe_soir."/";
      	
      	return $return_data;
      }
      
      /* Function qui va lire le fichier XML */
      private function _read_xml($xml)
      {
         $data= '' ;
         
      	//On recupere ce qu'il y a entre les item
      	$explode_item = explode('<item>',$xml);
      	$explode_item = explode('</item>',$explode_item[1]);
      	$item_content = $explode_item[0];
      	
      	//On regarde le title
      	preg_match("#<title>(.*)</title>#",$item_content,$title); 
      	
      	$title = $title[1];
      	
      	//Si la ville n'est pas trouvee, on retourne NO
      	if($title == 'City not found')
      	{
      		$data .= "NO";
      	}
      	//Si l'API retourne les donnees on les lit
      	else
      	{
      		//Le lien
      		preg_match("#<link>(.*)</link>#",$item_content,$link); 
      		$link = $link[1];
      		$data .= $link."<br><br>";
      		$data .= $title."<br><br>";
      		$explode_weather = explode('<meteo:weather',$item_content);
      		for($i=1;$i<count($explode_weather);$i++){
      		$data .= $this->_extract_data($explode_weather[$i])."<br>";
      		}
      	}
      	return $data;	
      }
      
      //Function qui permet d'afficher les conditions meteo pour la latitude/longitude de son choix, tres utile pour creer des pages dediees pour chaque ville
      private function _display($latitude,$longitude,$nom_ville)
      {	
        	//On recupere la date d'il y a 4 heures pour la comparer  l'heure actuelle
         $date = date('YmdHi',strtotime('-4 hours'));
         $html = '' ;		
     	   //On encode le nom de la ville en md5 pour creer le fichier de donnees
     	   $nom_file = $this->_chemin."/".md5($nom_ville).".txt";
                  
         if (($this->_cache  == 'yes') && (file_exists($nom_file)))
      	{
            
     	      //On ouvre le fichier et on le lit
     	      $fp = fopen($nom_file,"a+"); 
     	      while (!feof($fp)) 
     	      {
     	      	$file .= fgets($fp, 4096);
     	      }
     	      
     	      //On regarde si une balise <heure> est presente
     	      //eregi("<heure>(.*)</heure>",$file,$heure); 
     	      preg_match("#<heure>(.*)</heure>#",$file,$heure); 
              
     	      $heure = $heure[1];
     	      
     	      //Si la date dans la balise heure est superieure  l'actuelle, on ne met pas  jour le fichier
     	      if($heure >= $date)
     	      {
     	      	$update = "no";
     	      }
     	      else
     	      {
     	      	$update = "ok";
     	      }
         }
         else
         {
            $update = "ok";
         }
      	
      	//L'update des donnees
      	if($update == 'ok')
      	{		    	
      		if ($this->_mode == 'ville')
      		{
      		   $url= 'http://api.meteorologic.net/forecarss?p='.urlencode($nom_ville);
      	   }
      	   else
      	   {
         	   $url= 'http://api.meteorologic.net/rssworld?lat='.urlencode($latitude).'&lon='.urlencode($longitude) ;
      	   }

      		$xml_page = $this->_getContent ($url) ;
      		
      			
      		//La on va recuperer les donnees
      		$data = $this->_read_xml($xml_page);
      	     		     	
      		if($data == 'NO')
      		{
      			$html = "Pas de donnees";
      		}
      		else
      		{	
      			//Link
      			$link1 = explode('<br><br>',$data);
      			$link = $link1[0];
      		
      			//Donnees
      			$data = $link1[2];
      			           
      			if ($this->_affichage == 'default')
      			{	
         			$html .= "<strong>M&eacute;t&eacute;o ".$nom_ville."</strong><br />";
      			   //On explode les <br>
      			   $explode = explode('<br>',$data);			   
      			   $limite = count($explode)-1 ;
      			   
      			   if ($this->_profondeur==0)
      			   {
         			   $this->_profondeur = $limite ;   			  
      			   }
      			   else
      			   {
         			   if ($this->_profondeur > $limite)
         			   {
            			   $this->_profondeur = $limite ;   			  
         			   }
      			   }
      			   
      			   for($i=0 ; $i<$this->_profondeur ; $i++)
      			   {
      			   	list($date,$pictos_matin,$namepictos_matin,$tempe_matin,$pictos_midi,$namepictos_midi,$tempe_midi,$pictos_apmidi,$namepictos_apmidi,$tempe_apmidi,$pictos_soir,$namepictos_soir,$tempe_soir) = preg_split("_/_",$explode[$i]);
      		      
      			   	//On genere le html
      			   	$html .= "<p><strong>".$date."</strong></p>";
      		      
      			   	//Le matin
      			   	if($pictos_matin != "")
      			   	{
      			   		$html .= "<div style='float:left;width:75px;border:1px solid black;padding:5px;height:120px;text-align:center;'><strong>Matin</strong><br /><img src='".$this->_adresse."/".$pictos_matin.$this->_extension."' /><br /><strong>".$namepictos_matin."</strong><br />".round($tempe_matin)."&deg;C</div>";
      			   	}
      			   	//Midi
      			   	if($pictos_midi != "")
      			   	{
      			   		$html .= "<div style='float:left;width:75px;border:1px solid black;padding:5px;height:120px;text-align:center;'><strong>Midi</strong><br /><img src='".$this->_adresse."/".$pictos_midi.$this->_extension."' /><br /><strong>".$namepictos_midi."</strong><br />".round($tempe_midi)."&deg;C</div>";
      			   	}
      			   	//Apres midi
      			   	if($pictos_apmidi != "")
      			   	{
      			   		$html .= "<div style='float:left;width:75px;border:1px solid black;padding:5px;height:120px;text-align:center;'><strong>Apr&egrave;s-midi</strong><br /><img src='".$this->_adresse."/".$pictos_apmidi.$this->_extension."' /><br /><strong>".$namepictos_apmidi."</strong><br />".round($tempe_apmidi)."&deg;C</div>";
      			   	}
      			   	//Soir
      			   	if($pictos_soir != "")
      			   	{
      			   		$html .= "<div style='float:left;width:75px;border:1px solid black;padding:5px;height:120px;text-align:center;'><strong>Soir</strong><br /><img src='".$this->_adresse."/".$pictos_soir.$this->_extension."' /><br /><strong>".$namepictos_soir."</strong><br />".round($tempe_soir)."&deg;C</div>";
      			   	}
      			   	      		      
      			   	$html .= "<div style='clear:both;'></div><br />";
      			   //Fin du for
      			   }
               } 
      			//fin du default
      			if ($this->_affichage == 'tab')
      			{	
         			$html .= "<strong>M&eacute;t&eacute;o ".$nom_ville."</strong><br />
                  <table style=\"color:white;\">";
                  //On explode les <br>
                  $explode = explode('<br>',$data);
      			   if ($this->_profondeur==0)
      			   {
         			   $this->_profondeur = count($explode)-1 ;   			  
      			   }
      			   else
      			   {
         			   if ($this->_profondeur > count($explode)-1)
         			   {
            			   $this->_profondeur = count($explode)-1 ;   			  
         			   }
      			   }
      			   for($i=0 ; $i<$this->_profondeur ; $i++)
                  {
                     list($date,$pictos_matin,$namepictos_matin,$tempe_matin,$pictos_midi,$namepictos_midi,$tempe_midi,$pictos_apmidi,$namepictos_apmidi,$tempe_apmidi,$pictos_soir,$namepictos_soir,$tempe_soir) = preg_split("_/_",$explode[$i]);
                     
                     if($i== 0){ $style= 'display:block;'; } else{  $style= 'display:none;'; }
                     //On genere le html
                     $html .= '
                     <tr style="background-color:#306A8F;height:40px;">
                     	<td style="border-left:1px solid white;"></td>
                     	<td style="border-left:1px solid white;width:200px;padding-left:5px;">
                     	<a style="color:white;cursor:pointer;" onclick="affich(\''.$i.'\');">'.$date.'</a>
                     	<td style="border-left:1px solid white;width:200px;padding-left:5px;">Temps</td>
                     	<td style="border-left:1px solid white;width:100px;text-align:center;padding-left:5px;">Temp&eacute;ratures
                     	</td>
                     	<td style="border:1px solid white;"></td>
                     </tr>
                     <div id="'.$i.'">
                     ';
                     
                     //Le matin
                     if($pictos_matin != "")
                     {
                        $html .= "
                        <tr style='background-color:#F6F5F5;height:40px;color:black;'>
                        	<td style='border-left:1px solid white;'></td>
                        	<td style='border-left:1px solid white;width:200px;padding-left:5px;'>
                        	<a style='color:black;cursor:pointer;'>Matin</a></td>
                        	<td style='border-left:1px solid white;width:200px;'><img align='absmiddle' src='".$this->_adresse."/".$pictos_matin.$this->_extension."' /> 
                        	<span style='vertical-align: middle;'><strong>".$namepictos_matin."</strong></span></td>
                        	<td style='border-left:1px solid white;width:100px;text-align:center;'>".round($tempe_matin)."&deg;C
                        	</td>
                        	<td style='border:1px solid white;'></td>
                        </tr>";
                     }
                     //Midi
                     if($pictos_midi != "")
                     {
                        $html .= "
                        <tr style='background-color:#EBE9E9;height:40px;color:black;'>
                        	<td style='border-left:1px solid white;'></td>
                        	<td style='border-left:1px solid white;width:100px;padding-left:5px;'>
                        	<a style='color:black;cursor:pointer;'>Midi</a></td>
                        	<td style='border-left:1px solid white;width:200px;vertical-align: middle;'><img align='absmiddle' src='".$this->_adresse."/".$pictos_midi.$this->_extension."' /> 
                        	<span style='vertical-align: middle;'><strong>".$namepictos_midi."</strong></span></td>
                        	<td style='border-left:1px solid white;width:100px;text-align:center;'>".round($tempe_midi)."&deg;C
                        	</td>
                        	<td style='border:1px solid white;'></td>
                        </tr>";
                     }
                     //Apres midi
                     if($pictos_apmidi != "")
                     {
                        $html .= "
                        <tr style='background-color:#F6F5F5;height:40px;color:black;'>
                        	<td style='border-left:1px solid white;'></td>
                        	<td style='border-left:1px solid white;width:100px;padding-left:5px;'>
                        	<a style='color:black;cursor:pointer;'>Apr&egrave;s-Midi</a></td>
                        	<td style='border-left:1px solid white;width:200px;vertical-align: middle;'><img align='absmiddle' src='".$this->_adresse."/".$pictos_apmidi.$this->_extension."' /> 
                        	<span style='vertical-align: middle;'><strong>".$namepictos_apmidi."</strong></span></td>
                        	<td style='border-left:1px solid white;width:100px;text-align:center;'>".round($tempe_apmidi)."&deg;C
                        	</td>
                        	<td style='border:1px solid white;'></td>
                        </tr>";
                     }
                     //Soir
                     if($pictos_soir != "")
                     {
                        $html .= "
                        <tr style='background-color:#EBE9E9;height:40px;color:black;'>
                        	<td style='border-left:1px solid white;'></td>
                        	<td style='border-left:1px solid white;width:100px;padding-left:5px;'>
                        	<a style='color:black;cursor:pointer;'>Soir</a></td>
                        	<td style='border-left:1px solid white;width:100px;vertical-align: middle;'><img align='absmiddle' src='".$this->_adresse."/".$pictos_soir.$this->_extension."' /> 
                        	<span style='vertical-align: middle;'><strong>".$namepictos_soir."</strong></span></td>
                        	<td style='border-left:1px solid white;width:100px;text-align:center;'>".round($tempe_soir)."&deg;C
                        	</td>
                        	<td style='border:1px solid white;'></td>
                        </tr>";
                     }
                     $html .= "</div><br />";                                
                  //Fin du for
                  }           
                  $html .= "</table><br />";   			
      			//fin du tab
      		   }
               
      			//On affiche le lien pour respecter les CGU
      			if($this->_linkCGU == 'yes'){
      				$html .= "<a href='http://www.meteorologic.net/' target='_blank'>Donn&eacute;es m&eacute;t&eacute;o de www.meteorologic.net</a>";
      			}else{
      				$html .= "Donn&eacute;es m&eacute;t&eacute;o : <a href='http://www.meteorologic.net/' target='_blank'>M&eacute;t&eacute;orologic</a>";
      			}
      	
      		//else($data != 'NO')
      		}
         	if ($this->_cache  =='yes') 
         	{
      	   	//On va maintenant stocker ces donnees dans le fichier
      	   	@unlink($nom_file);
      	   	$date_actuelle = date('YmdHi');
      	   	$fp = fopen($nom_file,"w"); 
      	   	$texte = "<heure>".$date_actuelle."</heure>
      	   	/******* HTML *******/
      	   	".$html."";
      	   
      	   	fwrite($fp,$texte);
      	   	fclose($fp);
      	   	// FIn de l'update  OK
            }
      	}
      	else{
      		//On recupere le contenu html dans le fichier
      		$html = explode('/******* HTML *******/',$file);
      		$html = $html[1];
      	}
      	
      	return $html;
      	//Fin de la function display
      } 
      
      /*
       * Retourne le code source d'une page web
       */
      private function _getContent($url) 
      {
         // Fichier local ou pas  
         if ((substr($url, 0, 17)=='http://127.0.0.1/') || (substr($url, 0, 17)=='http://localhost/')) {
            $local = true;	
            $url = str_replace('/',DS,str_replace(JURI::root(), JPATH_ROOT.DS, $url));
         } else {
         	$local = false;	
   	  }
   
   	  $local = false;	
        $sReturn = null;
   	  
   	  if ($local==false) {
         
            // Retrouve la page.   Il faut que curl soit activ? dans php.ini : il faut que la ligne "extension=php_curl.dll" ne soit plus en commentaire
   
            try {             
               if  (in_array  ('curl', get_loaded_extensions())) {
   
                  $ch = curl_init();                           // Initialize a CURL session.
                  curl_setopt($ch, CURLOPT_URL, $url);         // Pass URL as parameter.
                  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); // Return Page contents.
                  curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 2);
                  curl_setopt($ch, CURLOPT_TIMEOUT, 2);
                  curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
                  curl_setopt($ch, CURLOPT_VERBOSE, true);
   
                  try {            	
                     $sReturn = curl_exec($ch);                  // grab URL and pass it to the variable.
                  } catch (Exception $e) {
                    // AllEventsHelperDebug::console('error',$e->getMessage(),null,1);
                    // throw new Exception("Error with cURL request");
                  }
   
                  curl_close($ch);                             // close curl resource, and free up system resources.
   
               } else { // if  (in_array  ('curl', get_loaded_extensions())) {
            	
                  //AllEventsHelperDebug::console('error','curl is not loaded.   You\'ll need to open your php.ini file and uncomment the line "extension=php_curl.dll".',null,1);
   
               } // if  (in_array  ('curl', get_loaded_extensions()))
   
            } catch (Exception $e) {
               //AllEventsHelperDebug::console('error', 'curl is not loaded.   You\'ll need to open your php.ini file and uncomment the line "extension=php_curl.dll".',null,1);
            } // try
            
         } else { // if ($local==false)
         	
            // Fichier local	
         	 $c = fopen($url,"r");
            $sReturn = fread($c, filesize($url));
            //$sReturn = htmlspecialchars($sReturn);
   		 
   	  } // if ($local==false)
   
         return JString::trim($sReturn);
   
      } // public function getHTMLContent($url)
   }
?> 